Unit ip2url;
{ ip2url translates ip-numbers to ip-names using the unit inet
  (C)2001 by gerd@dg4fac.de Version 0.7
  created 14.04.2001 for fpk-Pascal under
  SuSE-Linux 7.1, last change 08.07.2001
}

Interface
Uses inet,SysUtils;

Var
  fHostNotFound,fDnsOk:Boolean;
  sHostFile:String;

{ Interface routines }
Procedure ReadAllHosts;
Procedure TranslateAllMissingIps;
Procedure FindIpCreateIfNone(sIp,sUrl:String;i:LongInt);
Function FindIp(s:String):String;
Procedure SaveAllHosts;
Procedure DeleteAllIps;
Procedure CheckDns(fQuiet:Boolean);

{ Routines for tests
Procedure CheckIps;
Procedure WriteAllIps;
Procedure CountAllIps;
}

Implementation

Uses weberr,webstring;

Const
  iMaxDays=180;

Type
  pStruct4=^TStruct4;
  TStruct4=Record
    bThis:Byte;
    sUrl:String[64];
    iDays:LongInt;
    pNext:pStruct4;
    End;

  pStruct3=^TStruct3;
  TStruct3=Record
    bThis:Byte;
    pThis:pStruct4;
    pNext:pStruct3;
    End;

  pStruct2=^TStruct2;
  TStruct2=Record
    bThis:Byte;
    pThis:pStruct3;
    pNext:pStruct2;
    End;

  pStruct1=^TStruct1;
  TStruct1=Record
    bThis:Byte;
    pThis:pStruct2;
    pNext:pStruct1;
    End;

Var
  p:PHostEnt;
  adr:THostAddr;
  p0,p1,p1n,p1p:pStruct1;
  p2,p2n,p2p:pStruct2;
  p3,p3n,p3p:pStruct3;
  p4,p4n,p4p:pStruct4;
  ba:Array[1..4] Of Byte;
  iToday:LongInt;

Function ipText2ipArray(s:String):Boolean;
Var i,k,l:LongInt;
Begin
l:=Length(s);
i:=0;
k:=0;
While (i<4) And (k<l) Do
  Begin
  Inc(i);
  ba[i]:=0;
  Inc(k);
  While (k<=l) And (s[k]<>'.') Do
    Begin
    ba[i]:=10*ba[i]+(Byte(s[k])-48);
    Inc(k);
    End;
  End;
ipText2ipArray:=i=4;
End;

Function FindIp(s:String):String;
Begin
FindIp:='(Not found!)';
ipText2ipArray(s);
p1:=p0;
While (p1<>NIL) And (ba[1]>p1^.bThis) Do p1:=p1^.pNext;
If (p1<>NIL) And (ba[1]=p1^.bThis) Then
  Begin
  p2:=p1^.pThis;
  While (p2<>NIL) And (ba[2]>p2^.bThis) Do p2:=p2^.pNext;
  If (p2<>NIL) And (ba[2]=p2^.bThis) Then
    Begin
    p3:=p2^.pThis;
    While (p3<>NIL) And (ba[3]>p3^.bThis) Do p3:=p3^.pNext;
    If (p3<>NIL) And (ba[3]=p3^.bThis) Then
      Begin
      p4:=p3^.pThis;
      While (p4<>NIL) And (ba[4]>p4^.bThis) Do p4:=p4^.pNext;
      If (p4<>NIL) And (ba[4]=p4^.bThis) Then FindIp:=p4^.sUrl;
      End;
    End;
  End;
End;

Procedure CreateNew4;
Begin
New(p4);
With p4^ Do
  Begin
  bThis:=ba[4];
  sUrl:='';
  iDays:=0;
  pNext:=NIL;
  End;
End;

Procedure CreateNew3;
Begin
New(p3);
CreateNew4;
With p3^ Do
  Begin
  bThis:=ba[3];
  pThis:=p4;
  pNext:=NIL;
  End;
End;

Procedure CreateNew2;
Begin
New(p2);
CreateNew3;
With p2^ Do
  Begin
  bThis:=ba[2];
  pThis:=p3;
  pNext:=NIL;
  End;
End;

Procedure CreateNew1;
Begin
New(p1);
CreateNew2;
With p1^ Do
  Begin
  bThis:=ba[1];
  pThis:=p2;
  pNext:=NIL;
  End;
End;

Procedure FindIpCreateIfNone(sIp,sUrl:String;i:LongInt);
Begin
ipText2ipArray(sIp);
If p0=NIL Then
  Begin
  CreateNew1;
  p0:=p1;
  End Else
  Begin
  p1:=p0;
  If ba[1]<p1^.bThis Then
    Begin
    CreateNew1;
    p1^.pNext:=p0;
    p0:=p1;
    End Else
    Begin
    While (p1<>NIL) And (ba[1]>p1^.bThis) Do
      Begin
      p1p:=p1;
      p1:=p1^.pNext;
      End;
    If p1=NIL Then
      Begin
      CreateNew1;
      p1p^.pNext:=p1;
      End Else
      Begin
      If ba[1]<>p1^.bThis Then
        Begin
        p1n:=p1;
        CreateNew1;
        p1^.pNext:=p1n;
        p1p^.pNext:=p1;
        End Else
        Begin
        p2:=p1^.pThis;
        If ba[2]<p2^.bThis Then
          Begin
          p2n:=p2;
          CreateNew2;
          p1^.pThis:=p2;
          p2^.pNext:=p2n;
          End Else
          Begin
          While (p2<>NIL) And (ba[2]>p2^.bThis) Do
            Begin
            p2p:=p2;
            p2:=p2^.pNext;
            End;
          If p2=NIL Then
            Begin
            CreateNew2;
            p2p^.pNext:=p2;
            End Else
            Begin
            If ba[2]<>p2^.bThis Then
              Begin
              p2n:=p2;
              CreateNew2;
              p2p^.pNext:=p2;
              p2^.pNext:=p2n;
              End Else
              Begin
              p3:=p2^.pThis;
              If ba[3]<p3^.bThis Then
                Begin
                p3n:=p3;
                CreateNew3;
                p2^.pThis:=p3;
                p3^.pNext:=p3n;
                End Else
                Begin
                While (p3<>NIL) And (ba[3]>p3^.bThis) Do
                  Begin
                  p3p:=p3;
                  p3:=p3^.pNext;
                  End;
                If p3=NIL Then
                  Begin
                  CreateNew3;
                  p3p^.pNext:=p3;
                  End Else
                  Begin
                  If ba[3]<>p3^.bThis Then
                    Begin
                    p3n:=p3;
                    CreateNew3;
                    p3p^.pNext:=p3;
                    p3^.pNext:=p3n;
                    End Else
                    Begin
                    p4:=p3^.pThis;
                    If ba[4]<p4^.bThis Then
                      Begin
                      p4n:=p4;
                      CreateNew4;
                      p3^.pThis:=p4;
                      p4^.pNext:=p4n;
                      End Else
                      Begin
                      While (p4<>NIL) And (ba[4]>p4^.bThis) Do
                        Begin
                        p4p:=p4;
                        p4:=p4^.pNext;
                        End;
                      If p4=NIL Then
                        Begin
                        CreateNew4;
                        p4p^.pNext:=p4;
                        End Else
                        Begin
                        If ba[4]<>p4^.bThis Then
                          Begin
                          p4n:=p4;
                          CreateNew4;
                          p4^.pNext:=p4n;
                          p4p^.pNext:=p4;
                          End;
                        End;
                      End;
                    End;
                  End;
                End;
              End;
            End;
          End;
        End;
      End;
    End;
  End;
If sUrl<>'' Then p4^.sUrl:=sUrl;
If i<>0 Then p4^.iDays:=i;
End;

Procedure DeleteAllIps;
Begin
p1:=p0;
While p1<>NIL Do
  Begin
  p2:=p1^.pThis;
  While p2<>NIL Do
    Begin
    p3:=p2^.pThis;
    While p3<>NIL Do
      Begin
      p4:=p3^.pThis;
      While p4<>NIL Do
        Begin
        p4n:=p4;
        p4:=p4^.pNext;
        Dispose(p4n);
        End;
      p3n:=p3;
      p3:=p3^.pNext;
      Dispose(p3n);
      End;
    p2n:=p2;
    p2:=p2^.pNext;
    Dispose(p2n);
    End;
  p1n:=p1;
  p1:=p1^.pNext;
  Dispose(p1n);
  End;
p0:=NIL;
End;

Procedure ReadAllHosts;
Var f:Text;
    sUrl,sIp,z:String;
    i,n,p,pd:LongInt;
    err:Word;
Begin
Write(ws[igrpws[msgGroup].ia+21],' ',sHostFile,' ... ');
If FileExists(sHostFile) Then
  Begin
  Assign(f,shostfile);
  Reset(f);
  n:=1;
  While Not Eof(f) Do
    Begin
    Readln(f,z);
    p:=Pos('=',z);
    If p>0 Then
      Begin
      sIp:=Copy(z,1,p-1);
      pd:=Pos(';',z);
      If pd<1 Then
        Begin
        sUrl:=Copy(z,p+1,255);
        i:=iToday-Random(7);
        End Else
        Begin
        sUrl:=Copy(z,p+1,pd-p-1);
        Val(Copy(z,pd+1,255),i,err);
        If err<>0 Then i:=iToday-Random(iMaxDays);
        End;
      If Length(sUrl)>64 Then
        Begin
        Writeln('!');
        WebErrOut(sHostFile,'Line '+IntToStr(n)+', Url: '+sUrl+', Url-String is too long');
        End;
      If (iToday-i)<iMaxDays Then FindIpCreateIfNone(sIp,sUrl,i);
      End Else
      Begin
      Writeln('!');
      WebErrOut(sHostFile,'Line '+IntToStr(n)+', Separator = missing');
      End;
    Inc(n);
    End;
  Close(f);
  Writeln(n,ws[igrpws[msgGroup].ia+12]);
  End Else
  Begin
  Writeln(ws[igrpws[msgGroup].ia+23]);
  WebErrOut(sHostFile,'File not found');
  End;
End;

Function FindUndefinedNext:Boolean;
Begin
Repeat
  p4:=p4^.pNext;
  If p4=NIL Then
    Begin
    p3:=p3^.pNext;
    If p3<>NIL Then
      Begin
      p4:=p3^.pThis;
      End Else
      Begin
      p2:=p2^.pNext;
      If p2<>NIL Then
        Begin
        p3:=p2^.pThis;
        p4:=p3^.pThis;
        End Else
        Begin
        p1:=p1^.pNext;
        If p1<>NIL Then
          Begin
          p2:=p1^.pThis;
          p3:=p2^.pThis;
          p4:=p3^.pThis;
          End;
        End;
      End;
    End;
  Until (p1=NIL) Or (p4^.sUrl='');
FindUndefinedNext:=(p1<>NIL);
End;

Function FindUndefinedFirst:Boolean;
Begin
If p0=NIL Then
  FindUndefinedFirst:=False Else
  Begin
  p1:=p0;
  p2:=p1^.pThis;
  p3:=p2^.pThis;
  p4:=p3^.pThis;
  If p4^.sUrl='' Then
    FindUndefinedFirst:=True Else
    FindUndefinedFirst:=FindUndefinedNext;
  End;
End;

Procedure TranslateAllMissingIps;
Var flg:Boolean;
  n,no,nu:LongInt;
Begin
n:=0;
no:=0;
nu:=0;
Write('ip2url: ');
flg:=FindUndefinedFirst;
While flg Do
  Begin
  Inc(n);
  adr[1]:=p1^.bThis;
  adr[2]:=p2^.bThis;
  adr[3]:=p3^.bThis;
  adr[4]:=p4^.bThis;
  p:=GetHostByAddr(@adr,4,2);
  If p=NIL Then
    Begin
    Inc(nu);
    p4^.sUrl:='(not found)';
    p4^.iDays:=iToday-iMaxDays+7;
    Write('-');
    End Else
    Begin
    Inc(no);
    p4^.sUrl:=p^.name;
    p4^.iDays:=iToday;
    Write('.');
    End;
  flg:=FindUndefinedNext;
  End;
Writeln(' ',ws[igrpws[msgGroup].ia+18]);
If n>0 Then Writeln('IPs: ',n,ws[igrpws[msgGroup].ia+23],' ',no,ws[igrpws[msgGroup].ia+24],' ',nu,ws[igrpws[msgGroup].ia+25]);
End;

Procedure CheckDns(fquiet:Boolean);
Begin
If Not fQuiet Then Write('DNS-check (212.227.109.30) ... ');
adr[1]:=212;
adr[2]:=227;
adr[3]:=109;
adr[4]:=30;
fDnsOk:=GetHostByAddr(@adr,4,2)<>NIL;
If Not fQuiet Then
  Begin
  If fDnsOk Then Writeln('ok.') Else Writeln(ws[igrpws[msgGroup].ia+25]);
  End;
End;

Procedure SaveAllHosts;
Var sBakFile:String;
  f:Text;
  n:LongInt;
Begin
n:=0;
Write(ws[igrpws[msgGroup].ia+29],' ');
If p0=NIL Then
  Begin
  Writeln(ws[igrpws[msgGroup].ia+27]);
  WebErrOut(sHostFile,'IP-list is empty, not saved');
  End Else
  Begin
  sBakFile:=shostfile+'~';
  If FileExists(sBakFile) Then DeleteFile(sBakFile);
  If FileExists(sHostFile) Then
    Begin
    If Not RenameFile(shostFile,sBakFile) Then
      Begin
      Writeln(ws[igrpws[msgGroup].ia+28]);
      WebErrOut(sHostFile,'Failed renaming to '+sBakFile);
      End;
    End;
  Assign(f,shostFile);
  ReWrite(f);
  p1:=p0;
  While p1<>NIL Do
    Begin
    p2:=p1^.pThis;
    While p2<>NIL Do
      Begin
      p3:=p2^.pThis;
      While p3<>NIL Do
        Begin
        p4:=p3^.pThis;
        While p4<>NIL Do
          Begin
          Inc(n);
          Writeln(f,p1^.bThis,'.',p2^.bThis,'.',p3^.bThis,'.',p4^.bThis,'=',p4^.sUrl,';',p4^.iDays);
          p4:=p4^.pNext;
          End;
        p3:=p3^.pNext;
        End;
      p2:=p2^.pNext;
      End;
    p1:=p1^.pNext;
    End;
  Close(f);
  Writeln(n,' ',ws[igrpws[msgGroup].ia+12]);
  End;
End;

Begin
Randomize;
fHostNotFound:=False;
p0:=NIL;
iToday:=Trunc(Date);
End.
