Unit webfiles;
{ Treat result files
  Unit for Weblox version 0.7
  Last Change 09.07.2001
}

Interface

Const
  Run_mode_year=1;
  Run_mode_month=2;
  Run_mode_week=3;

Type
  pFileList=^TFileList;
  TFileList=Record
    sname,sename:String;
    fcomplete:Boolean;
    nff,nbf,nvf:LongInt;
    pnext,pprev:pFileList;
    End;

Var
  FileResults:String;
  ap:Array[1..3] Of pFileList;
  slogf:Array[1..3] Of String;
  actual:Array[1..3] Of String;

Procedure FileReadLists;
Procedure FileSetResult(run_mode:Byte;sfn:String;fc:Boolean;sen:String);
Procedure FileSaveCloseLists;

Implementation

Uses SysUtils,weblist,weberr,webstring;

Var
  k:LongInt;

Procedure FileSetEntry(run_mode:Byte;Var r:TFileList);
Var pf,pp:pFileList;
Begin
If ap[run_mode]=NIL Then
  Begin
  New(ap[run_mode]);
  pf:=ap[run_mode];
  pf^.pnext:=NIL;
  pf^.pprev:=NIL;
  End Else
  Begin
  pf:=ap[run_mode];
  While (pf^.sname<>r.sname) And (pf^.pnext<>NIL) Do pf:=pf^.pnext;
  If pf^.sname<>r.sname Then
    Begin
    New(pf^.pnext);
    pp:=pf;
    pf:=pf^.pnext;
    pf^.pnext:=NIL;
    pf^.pprev:=pp;
    End;
  End;
With pf^ Do
  Begin
  sname:=r.sname;
  sename:=r.sename;
  fcomplete:=r.fcomplete;
  nff:=r.nff;
  nbf:=r.nbf;
  nvf:=r.nvf;
  End;
End;

Procedure FileSetResult(run_mode:Byte;sfn:string;fc:Boolean;sen:String);
Var r:TFileList;
Begin
With r Do
  Begin
  sname:=sfn;
  sename:=sen;
  fcomplete:=fc;
  nff:=ListGetList(ListFiles).ns;
  nbf:=ListGetList(ListFiles).nks;
  nvf:=ListGetList(ListIp).nvs;
  End;
FileSetEntry(run_mode,r);
End;

Function FileGetNumber(Var s:String;b:Byte):LongInt;
Var k,l:Byte;
  n:LongInt;
Begin
l:=Length(s);
n:=0;
k:=b;
While (k<=l) And (s[k]=' ') Do Inc(k);
While (k<=l) And (s[k]>='0') And (s[k]<='9') Do
  Begin
  n:=10*n+Byte(s[k])-48;
  Inc(k);
  End;
FileGetNumber:=n;
End;

Procedure FileReadLists;
Var f:Text;
  s:String;
  run_mode,pc,pf,pb,pv,ps:Byte;
  r:TFileList;
Begin
If FileExists(FileResults) Then
  Begin
  Write(ws[igrpws[msgGroup].ia+40],' ');
  Assign(f,FileResults);
  Reset(f);
  While Not Eof(f) Do
    Begin
    Readln(f,s);
    If s<>'' Then
      Begin
      Case s[1] Of
        '#','/','*':
          Begin
          End;
        '{':
          Begin
      	  If Pos('Years',s)>0 Then
      	    Run_Mode:=Run_Mode_Year Else
      	    Begin
      	    If Pos('Monthes',s)>0 Then
      	      Run_Mode:=Run_Mode_Month Else
      	        Begin
      	        If Pos('Weeks',s)>0 Then
      	          Run_Mode:=Run_Mode_Week Else
                  Begin
                  Writeln(ws[igrpws[msgGroup].ia+31],' "',s,'"!');
                  WebErrOut(FileResults,'Unknown option '+s);
                  End;
      	        End;
      	    End;
          End;
        Else
        With r Do
          Begin
          pc:=Pos('complete',s);
          pf:=Pos('files=',s);
          pb:=Pos('kBytes=',s);
          pv:=Pos('visits=',s);
          ps:=Pos('log=',s);
          If (pc>0) And (pf>0) And (pb>0) And (pv>0) And (ps>0) Then
            Begin
            fcomplete:=Pos('incomplete',s)<1;
            nff:=FileGetNumber(s,pf+6);
            nbf:=FileGetNumber(s,pb+7);
            nvf:=FileGetNumber(s,pv+7);
            sename:=Copy(s,ps+4,255);
            End Else
            Begin
            fcomplete:=False;
            Writeln(ws[igrpws[msgGroup].ia+32],' "',s,'"!');
            WebErrOut(FileResults,'Incomplete info '+s);
            End;
          sName:='';
          If fcomplete Then
            Begin
            Case Run_Mode Of
              Run_Mode_Year:
                If (s[5]='y') And (s[6]=':') Then
                  sname:=Copy(s,1,5);
              Run_Mode_Month:
                If (s[5]='m') And (s[8]=':') Then
                  sname:=Copy(s,1,7);
              Run_Mode_Week:
                If (s[5]='w') And (s[8]=':') Then
                  sname:=Copy(s,1,7);
              Else
              Writeln('info "',s,'" ',ws[igrpws[msgGroup].ia+33]);
              WebErrOut(FileResults,'Info '+s+' without correct run mode');
              End;
            If sname<>'' Then
              FileSetEntry(run_mode,r) Else
              Begin
              Writeln(ws[igrpws[msgGroup].ia+34],' "',s,'"!');
              WebErrOut(FileResults,'Incorrect line: '+s);
              End;
            End Else
            Begin
            If slogf[Run_Mode]='' Then
              Begin
	      slogf[Run_Mode]:=sename;
	      Case Run_Mode of
	        Run_Mode_Year:actual[Run_Mode]:=Copy(s,1,5);
	        Run_Mode_Month,Run_Mode_Week:actual[Run_Mode]:=Copy(s,1,7);
	        End;
	      End;
            End;
          End;
        End;
      End;
    End;
  Close(f);
  Writeln(ws[igrpws[msgGroup].ia+18]);
  End;
End;

Procedure FileSaveCloseLists;
Var pf,pfn:pFileList;
  f:Text;
Begin
If FileResults<>'' Then
  Begin
  Assign(f,FileResults);
  ReWrite(f);
  Writeln(f,'# Results of weblox analysis #');
  For k:=1 To 3 Do
    Begin
    Case k Of
      run_mode_year: Writeln(f,'{ Years }');
      run_mode_month: Writeln(f,'{ Monthes }');
      run_mode_week: Writeln(f,'{ Weeks }');
      End;
    pf:=ap[k];
    While pf<>NIL Do
      Begin
      With pf^ Do
        Begin
        Write(f,sname,': ');
        If Not fcomplete Then Write(f,'in');
        Write(f,'complete, files=',nff);
        Write(f,', kBytes=',nbf);
        Write(f,', visits=',nvf);
        Writeln(f,', log=',sename);
        End;
      pf:=pf^.pnext;
      End;
    End;
  Close(f);
  End Else
  Begin
  Writeln(ws[igrpws[msgGroup].ia+35]);
  WebErrOut(FileResults,'Incorrect filename of result file');
  End;
For k:=1 To 3 Do
  Begin
  pf:=ap[k];
  While pf<>NIL Do
    Begin
    pfn:=pf^.pnext;
    Dispose(pf);
    pf:=pfn;
    End;
  End;
End;

Begin
For k:=1 To 3 Do
  Begin
  ap[k]:=NIL;
  slogf[k]:='';
  End;
End.
