{ WebOut unit for all result listing operations
  (C)2001 by gerd@dg4fac.de Version 0.8
  created 06.05.2000 for fpk-Pascal under
  SuSe-Linux 6.4, last change 05.01.2002
}

Unit webout;

Interface
Uses webfiles;

Const
  tlen=60; { text length in page }
  alist:Array[1..4] Of String=(
    '                   X',
    'X XXXXXXXXXXXXXXXXX ',
    'X  XXX              ',
    ' X                  ');

Type
  TOutputFlags=Record
    text_out,html_out,html_week,html_month,html_year,
    html_index:Boolean;
    End;
  THtml=Record
    bgcolor,copyright:String;
    iTables:LongInt;
    End;

Var
  cdecsep,cksep:Char;
  OutputFlags:TOutputFlags;
  sHtml:THtml;
  sTargetDir,sHtmlRobots,sHtmlDir,sHtmlVers,sHostUrl,sTitle:String;
  run_mode:Byte; { 3 runs, by year/month/week }
  fAnalyseYears:Boolean;
  {fi:Text;}

Procedure WebOutOpen(RunFile,Heading:String);
Procedure WebOutList(List:LongInt;SortBy:Byte);
Procedure WebOutClose(nBytes:LongInt);
Procedure WebDetail;
Procedure WebStatIndex;

Implementation
Uses Crt,Dos,SysUtils,weblist,webstring,webeng,webvers,weberr;
Const
  nHtmlHead=9;
  nHtmlToe=4;
Var
  ft,fhtml:Text;
  sao:Array[1..10] Of String;
  nao:LongInt;
  fname:String;

{ output formatting routines }

Function d2s(i:LongInt):String;
Var s:String;
  k:LongInt;
Begin
Str(i,s);
k:=Length(s)+1;
Repeat
  k:=k-3;
  If (k>1) And (s[k-1]<>' ') Then Insert(cksep,s,k);
  Until k<3;
d2s:=s;
End;

Function outform(s1:String;n:LongInt;se:String):Boolean;
Var s,s2:String;
  k,l2:LongInt;
Begin
s2:=d2s(n);
s:=s1+' . '+s2;
k:=Length(s1)+2;
l2:=Length(s2)+2;
nao:=1;
While Length(s)>tlen Do
  Begin
  sao[nao]:=Copy(s,1,tlen-l2);
  s:='   '+Copy(s,tlen-l2+1,255);
  k:=k-(tlen-l2)+3;
  Inc(nao);
  End;
While Length(s)<tlen Do Insert('.',s,k);
sao[nao]:=s+' '+se;
outform:=true;
End;

Function tform(s:String;i:LongInt):String;
Var st:String;
  k:LongInt;
Begin
st:=s+'  '+d2s(i);
k:=Length(s)+2;
While Length(st)<tlen Do Insert('.',st,k);
tform:=st;
End;

Function leading(i:Word):String;
Var s:String;
Begin
Str(i,s);
If Length(s)=1 Then s:='0'+s;
leading:=s;
End;

Function now:String;
Var s:String;
  w1,w2,w3,w4:Word;
Begin
GetDate(w1,w2,w3,w4);
Str(w1,s);
s:=s+Leading(w2)+Leading(w3)+';';
GetTime(w1,w2,w3,w4);
s:=s+Leading(w1)+Leading(w2)+Leading(w3)+Leading(w4);
now:=s;
End;

Function SortString(SortBy:Byte):String;
Var s:String;
Begin
Case SortBy Of
  SortByString:s:=ws[igrpws[htmlGroup].ia+4];
  SortByNumber:s:=ws[igrpws[htmlGroup].ia+5];
  SortByBytes:s:=ws[igrpws[htmlGroup].ia+6];
  SortByVisits:s:=ws[igrpws[htmlGroup].ia+7];
  Else
  s:=ws[igrpws[htmlGroup].ia+8];
  End;
SortString:=ws[igrpws[htmlGroup].ia+13]+' '+s;
End;

Function SortDim(SortBy:Byte):String;
Var s:String;
Begin
Case SortBy Of
  SortByString: s:=ws[igrpws[htmlGroup].ia+9];
  SortByNumber: s:=ws[igrpws[htmlGroup].ia+10];
  SortByBytes: s:=ws[igrpws[htmlGroup].ia+11];
  SortByVisits: s:=ws[igrpws[htmlGroup].ia+12];
  Else
  s:='???';
  End;
SortDim:=s;
End;

Function SortGetN(SortBy:Byte;n1,n2,n3:LongInt):LongInt;
Var n:LongInt;
Begin
Case SortBy Of
  SortByString,SortByNumber:n:=n1;
  SortByBytes:n:=n2;
  SortByVisits:n:=n3;
  Else
  n:=n1;
  End;
SortGetN:=n;
End;

Function fform(n1,n2:LongInt):String;
Var r:Extended;
  s:String;
Begin
If n2>0 Then
  Begin
  r:=100.0*n1/n2;
  Str(r:6:2,s);
  If Pos('.',s)>0 Then s[Pos('.',s)]:=cdecsep;
  End Else
  s:='-';
fform:=s;
End;

Function HtmlHead(p:Byte):String;
Begin
Case p Of
  1:HtmlHead:='<HTML>';
  2:HtmlHead:='<HEAD>';
  3:HtmlHead:='<TITLE>'+sTitle+'</TITLE>';
  4:HtmlHead:='<META NAME="GENERATOR" CONTENT="Weblox version '+webloxversion+'">';
  5:HtmlHead:='<META NAME="AUTHOR" CONTENT="Weblox version '+webloxversion+'">';
  6:HtmlHead:='<META NAME="CREATED" CONTENT="'+now+'">';
  7:HtmlHead:='<META NAME="ROBOTS" CONTENT="'+sHtmlRobots+'">';
  8:HtmlHead:='</HEAD>';
  9:HtmlHead:='<BODY BGCOLOR='+sHtml.bgcolor+'>';
  End;
End;

Function HtmlToe(p:Byte):String;
Begin
Case p Of
  1:HtmlToe:=sHtml.copyright;
  2:HtmlToe:=sHtmlVers;
  3:HtmlToe:='</BODY>';
  4:HtmlToe:='</HTML>';
  End;
End;

Procedure WebOutOpen(RunFile,Heading:String);
Var ior,k,l:LongInt;
  sTextTarget,sHtmlTarget:String;
Begin
fname:=RunFile;
If OutputFlags.text_out Then
  Begin
  sTextTarget:=sTargetDir+'/'+RunFile+'.txt';
  System.Assign(ft,sTextTarget);
  System.ReWrite(ft);
{  Writeln('Opening ',sTextTarget);}
  ior:=IOResult;
  If ior<>0 Then
    Begin
    Writeln(ws[igrpws[htmlGroup].ia+1],' ',sTextTarget);
    Writeln(ws[igrpws[htmlGroup].ia+2]);
    Writeln(ws[igrpws[htmlGroup].ia+3],' ',ior);
    ReadKey;
    Halt(3);
    End;
  Writeln(ft,Heading);
  For k:=1 To Length(Heading) Do Write(ft,'-');
  Writeln(ft);
  Writeln(ft);
  End;
If OutputFlags.html_out Then
  Begin
  sHtmlTarget:=sHtmlDir+'/'+Runfile+'.html';
  System.Assign(fhtml,sHtmlTarget);
  System.ReWrite(fhtml);
{  Writeln('Opening ',sHtmlTarget);}
  ior:=IOResult;
  If ior<>0 Then
    Begin
    Writeln(ws[igrpws[htmlGroup].ia+1],' ',sHtmlTarget);
    Writeln(ws[igrpws[htmlGroup].ia+2]);
    Writeln(ws[igrpws[htmlGroup].ia+3],' ',ior);
    ReadKey;
    Halt(3);
    End;
  sTitle:='Weblog '+ws[igrpws[htmlGroup].ia+14]+' http://'+sHostUrl;
  For k:=1 To nHtmlHead Do
    Writeln(fhtml,HtmlHead(k));
  Write(fhtml,'<A NAME="ptop"></A>Path: ');
  Writeln(fhtml,'<A HREF="../index.html" TARGET="_top">Home</A> ==>');
  Write(fhtml,'<A HREF="index.html">Log-Index</A> ==> <A HREF="');
  Case Runfile[5] Of
    'y':Write(fhtml,'years.html">',ws[igrpws[htmlGroup].ia+15]);
    'm':Write(fhtml,'monthes.html">',ws[igrpws[htmlGroup].ia+16]);
    'w':Write(fhtml,'weeks.html">',ws[igrpws[htmlGroup].ia+17]);
    End;
  Writeln(fhtml,ws[igrpws[htmlGroup].ia+18],'</A> ==> Log ',fname);
  Writeln(fhtml,'<H1>Weblog ',ws[igrpws[htmlGroup].ia+14],' http://',
    sHostUrl,'</H1>');
  Write(fhtml,'<H2>',ws[igrpws[htmlGroup].ia+19],' ',Copy(fname,1,4),' ');
  Case Runfile[5] Of
    'w':Write(fhtml,ws[igrpws[htmlGroup].ia+20],' ',Copy(fname,6,2));
    'm':Write(fhtml,ws[igrpws[htmlGroup].ia+21],' ',Copy(fname,6,2));
    End;
  Writeln(fhtml,'</H2>');
  Writeln(fhtml,'<TABLE BORDER=2><TR><TH>&nbsp;',ws[igrpws[htmlGroup].ia+51],
    '&nbsp;</TH>');
  For k:=1 To 4 Do
    Write(fhtml,'<TH>&nbsp;',ws[igrpws[sortGroup].ia+k],'&nbsp;</TH>');
  Writeln(fhtml,'</TR>');
  For k:=1 To Length(aList[1]) Do
    Begin
    Writeln(fhtml,'<TR><TD>',ws[igrpws[tGroup].ia+k],'</TD>');
    For l:=1 To 4 Do
      Begin
      If aList[l,k]='X' Then
        Write(fhtml,'<TD ALIGN=CENTER><A HREF="#',Copy(ws[igrpws[tGroup].ia],k,1),
          Copy(ws[igrpws[sortGroup].ia],l+1,1),'">X</A></TD>') Else
        Write(fhtml,'<TD ALIGN=CENTER>-</TD>');
      End;
    Writeln(fhtml,'</TR>');
    End;
  Writeln(fhtml,'</TABLE>');
  End;
End;

Procedure WebOutList(List:LongInt;SortBy:Byte);
Var i,k,l,n:LongInt;
  fh:Text;
  s,sfn:String;
  fout,fref:Boolean;
Begin
n:=ListGetList(List).ItemCount;
If n>0 Then
  Begin
  ListSort(List,SortBy);
  If OutputFlags.text_out Then
    Begin
    Writeln(ft,n,' ',ListGetList(List).s,SortString(SortBy));
    For k:=1 To n Do If ListGetElement(List,k) Then
      Begin
      outform(x.s,SortGetN(SortBy,x.n,x.nb,x.nv),SortDim(SortBy));
      For l:=1 To nao Do Writeln(ft,sao[l]);
      End;
    Writeln(ft,'---');
    End;
  End;
fout:=((Pos('w',fname)>0) And OutputFlags.html_week) Or
    ((Pos('y',fname)>0) And OutputFlags.html_year) Or
    ((Pos('m',fname)>0) And OutputFlags.html_month);
If (n>0) And (OutputFlags.html_out Or fout) Then
  Begin
  sfn:=sHtmlDir+'/'+fname+ListGetList(List).C1+ListGetList(List).C2+'.html';
  If fout Then
    Begin
    Assign(fh,sfn);
    ReWrite(fh);
{    Write('Open ',sfn,' ... ');}
    sTitle:='Weblog'+ws[igrpws[htmlGroup].ia+14]+' http://'+sHostUrl;
    For k:=1 To nHtmlHead Do
      Writeln(fh,HtmlHead(k));
    Write(fh,'<A NAME="ptop"></A>Path: ');
    Writeln(fh,'<A HREF="../index.html" TARGET="_top">Home</A> ==>');
    Write(fh,'<A HREF="index.html">Log-Index</A> ==> <A HREF="');
    Case fname[5] Of
      'y':Write(fh,'years.html">',ws[igrpws[htmlGroup].ia+15]);
      'm':Write(fh,'monthes.html">',ws[igrpws[htmlGroup].ia+16]);
      'w':Write(fh,'weeks.html">',ws[igrpws[htmlGroup].ia+17]);
      End;
    Writeln(fh,ws[igrpws[htmlGroup].ia+18],'</A> ==> Log ',fname);
    Writeln(fh,'<H1>Weblog',ws[igrpws[htmlGroup].ia+14],' http://',
      sHostUrl,'</H1>');
    Write(fh,'<H2>',ws[igrpws[htmlGroup].ia+19],Copy(fname,1,4));
    Case fname[5] Of
      'w':Write(fh,ws[igrpws[htmlGroup].ia+20],Copy(fname,6,2));
      'm':Write(fh,ws[igrpws[htmlGroup].ia+21],Copy(fname,6,2));
      End;
    Writeln(fh,'</H2>');
    End;
  k:=n;
  If n>sHtml.iTables Then n:=sHtml.iTables;
  If fout Then
    Begin
    Writeln(fh,'<H3>Top ',n,' ',ws[igrpws[htmlGroup].ia+22],' ',k,' ',
      ListGetList(List).s,' ',SortString(SortBy),'</H3>');
    Writeln(fh,'<TABLE BORDER=2>');
    Write(fh,'<TR><TH>&nbsp;',ListGetList(List).s,'&nbsp;</TH><TH>&nbsp;',SortDim(SortBy),
      '&nbsp;</TH><TH>&nbsp;%&nbsp;</TH></TR>');
    End;
  If OutputFlags.html_Out Then
    Begin
    Write(fhtml,'<A NAME="',ListGetList(List).C1,ListGetList(List).C2,
       '"> </A>');
    Writeln(fhtml,'<H3>Top ',n,' ',ws[igrpws[htmlGroup].ia+22],' ',k,' ',
      ListGetList(List).s,' ',SortString(SortBy),'</H3>');
    Writeln(fhtml,'<TABLE BORDER=2>');
    Write(fhtml,'<TR><TH ALIGN=RIGHT>&nbsp;N&nbsp;</TH><TH>&nbsp;',ListGetList(List).s,'&nbsp;</TH><TH>&nbsp;',SortDim(SortBy),
      '&nbsp;</TH><TH>&nbsp;%&nbsp;</TH></TR>');
    End;
  i:=SortGetN(SortBy,ListGetList(List).ns,ListGetList(List).nks,
    ListGetList(List).nvs);
  For k:=1 To n Do If ListGetElement(List,k) Then
    Begin
    l:=SortGetN(SortBy,x.n,x.nb,x.nv);
    If fout Then Write(fh,'<TR><TD ALIGN=LEFT>');
    If OutputFlags.html_out Then
      Write(fhtml,'<TR><TD ALIGN=RIGHT>',k,'</TD><TD ALIGN=LEFT>');
    s:=x.s;
    fref:=((List=ListRefe) Or (List=ListSE)) And (Length(s)<=70) And (Copy(s,1,7)='http://');
    Repeat
      If fout Then Writeln(fh,Copy(s,1,70));
      If OutputFlags.html_out Then
        Begin
        If fref Then
          Writeln(fhtml,'<A HREF="',s,'">',s,'</A>') Else
          Writeln(fhtml,Copy(s,1,70));
        End;
      s:=Copy(s,71,255);
      If s<>'' Then
        Begin
        If fout Then Write(fh,'<BR>&nbsp;&nbsp;&nbsp;');
        If OutputFlags.html_out Then
          Write(fhtml,'<BR>&nbsp;&nbsp;&nbsp;');
        End;
      Until s='';
    If fout Then Writeln(fh,'</TD><TD ALIGN=RIGHT>',
        d2s(l),'</TD><TD ALIGN=RIGHT>',fform(l,i),'</TD></TR>');
    If OutputFlags.html_out Then Writeln(fhtml,'</TD><TD ALIGN=RIGHT>',
        d2s(l),'</TD><TD ALIGN=RIGHT>',fform(l,i),'</TD></TR>');
    End;
  If fout Then
    Begin
    Writeln(fh,'<TR><TH ALIGN=LEFT>',ws[igrpws[htmlGroup].ia+23],
      '</TH><TH ALIGN=RIGHT>',d2s(i),
      '</TH><TH ALIGN=RIGHT>100.00</TH></TR>');
    Writeln(fh,'</TABLE>');
    Writeln(fh,'<A HREF="#ptop">',ws[igrpws[htmlGroup].ia+24],
      '</A><BR><BR>');
    End;
  If OutputFlags.html_out Then
    Begin
    Writeln(fhtml,'<TR><TH>&nbsp;&nbsp;&nbsp;</TH><TH ALIGN=LEFT>&nbsp;',ws[igrpws[htmlGroup].ia+23],
      '&nbsp;</TH><TH ALIGN=RIGHT>&nbsp;',d2s(i),
      '&nbsp;</TH><TH ALIGN=RIGHT>&nbsp;100.00&nbsp;</TH></TR>');
    Writeln(fhtml,'</TABLE><BR>');
    Writeln(fhtml,'<A HREF="#ptop">',ws[igrpws[htmlGroup].ia+24],
      '</A><BR><BR>');
    End;
  If fout Then
    Begin
    For k:=1 To nHtmlToe Do Writeln(fh,HtmlToe(k));
    Close(fh);
{    Writeln('close.');}
    End;
  End;
End;

Procedure WebStatIndex;
Var run_mode:Byte;
  s,sr:String;
  p:pFileList;
  fi:Text;
  fx:Boolean;
  k:Byte;
Begin
If OutputFlags.html_out And OutputFlags.html_index Then
  Begin
  Assign(fi,sHtmlDir+'/index.html');
  ReWrite(fi);
{  Writeln('Opening index file');}
  sTitle:='Weblog'+ws[igrpws[htmlGroup].ia+26]+' http://'+sHostUrl;
  For k:=1 To nHtmlHead Do
    Writeln(fi,HtmlHead(k));
  Writeln(fi,'<A NAME="ptop"></A>');
  Write(fi,'Path: <A HREF="../index.html" TARGET="_top">Home</A>');
  Writeln(fi,ws[igrpws[htmlGroup].ia+27]);
  Writeln(fi,'<H1>',ws[igrpws[htmlGroup].ia+26],' http://',sHostUrl,
    '</H1>');
  Writeln(fi,ws[igrpws[htmlGroup].ia+28]);
  Writeln(fi,'<UL><LI><A HREF="years.html">',ws[igrpws[htmlGroup].ia+29],
    '</A>,</LI>');
  Writeln(fi,'<LI><A HREF="monthes.html">',ws[igrpws[htmlGroup].ia+30],
    '</A>,</LI>');
  Writeln(fi,'<LI><A HREF="weeks.html">',ws[igrpws[htmlGroup].ia+31],
    '</A>.</LI></UL>');
  For run_mode:=1 To 3 Do
    Begin
    Write(fi,'<H2>');
    Case run_mode Of
      Run_Mode_Year:Write(fi,ws[igrpws[htmlGroup].ia+32]);
      Run_Mode_Month:Write(fi,ws[igrpws[htmlGroup].ia+33]);
      Run_Mode_Week:Write(fi,ws[igrpws[htmlGroup].ia+34]);
      End;
    Writeln(fi,'</H2>');
    p:=ap[Run_Mode];
    If p<>NIL Then
      Begin
      Writeln(fi,'<TABLE BORDER>');
      Case run_mode Of
        Run_Mode_Year:s:='';
        Run_Mode_Month:s:=ws[igrpws[htmlGroup].ia+35];
        Run_Mode_Week:s:=ws[igrpws[htmlGroup].ia+36];
        End;
      Write(fi,'<TR><TH>&nbsp;',ws[igrpws[htmlGroup].ia+37],'&nbsp;</TH>');
      If s<>'' Then Write(fi,'<TH>&nbsp;',s,'&nbsp;</TH>');
      Writeln(fi,'<TH ALIGN=RIGHT>&nbsp;',ws[igrpws[htmlGroup].ia+38],
        '&nbsp;</TH><TH ALIGN=RIGHT>&nbsp;',ws[igrpws[htmlGroup].ia+39],'&nbsp;</TH>');
      Writeln(fi,'<TH ALIGN=RIGHT>&nbsp;',ws[igrpws[htmlGroup].ia+40],
        '&nbsp;</TH></TR>');
      {Output resultlines}
      While p^.pnext<>NIL Do p:=p^.pnext;
      While p<>NIL Do
        Begin
        With p^ Do
          Begin
          sr:=sname+'.html';
          fx:=FileExists(sHtmlDir+'/'+sr);
          Write(fi,'<TR><TD ALIGN=LEFT>');
          If fx And (Run_Mode=Run_Mode_Year) Then Write(fi,'<A HREF="',sr,'">');
          Write(fi,Copy(sname,1,4));
          If fx And (Run_Mode=Run_Mode_Year) Then Write(fi,'</A>');
          Write(fi,'</TD><TD ALIGN=RIGHT>');
          If Run_Mode<>Run_Mode_Year Then
            Begin
            If fx Then Write(fi,'<A HREF="',sr,'">');
            Write(fi,Copy(sname,6,2),'</TD><TD ALIGN=RIGHT>');
            If fx Then Write(fi,'</A>');
            End;
          Write(fi,d2s(nff),'</TD><TD ALIGN=RIGHT>');
          Write(fi,d2s(nbf),'</TD><TD ALIGN=RIGHT>');
          Writeln(fi,d2s(nvf),'</TD></TR>');
          End;
        p:=p^.pprev;
        End;
      Writeln(fi,'</TABLE>');
      End Else
      Begin
      Writeln('Run mode ',run_mode,' has no data!');
      WebErrOut(sHtmlDir+'/index.html','Run mode '+IntToStr(run_mode)+' has no data');
      End;
    End;
  Writeln(fi,'<A HREF="#ptop">',ws[igrpws[htmlGroup].ia+24],
    '</A><BR><BR>');
  For k:=1 To nHtmlToe Do Writeln(fi,HtmlToe(k));
  Close(fi);
;  Writeln('Closing index file.');
  End;
End;

Procedure Detail(c:Char;s:String);
Var k,ka,ke,l,la,le,m,ma,me,n1,n2:LongInt;
  smw,sy:String;
  fi:Text;
Begin
Case c Of
  'y':Assign(fi,sHtmlDir+'/years.html');
  'm':Assign(fi,sHtmlDir+'/monthes.html');
  'w':Assign(fi,sHtmlDir+'/weeks.html');
  End;
ReWrite(fi);
{Write('Open detail ',c,' ... ');}
sTitle:='Weblog'+ws[igrpws[htmlGroup].ia+44]+' http://'+sHostUrl;
For k:=1 To nHtmlHead Do
  Writeln(fi,HtmlHead(k));
Writeln(fi,'<A NAME="ptop"></A>');
Writeln(fi,'Path: <A HREF="../index.html" TARGET="_top">Home</A> ==>');
Writeln(fi,'<A HREF="index.html">',ws[igrpws[htmlGroup].ia+42],'</A> ==> ',s);
Writeln(fi,'<H1>',s,ws[igrpws[htmlGroup].ia+44],
  'http://',sHostUrl,'</H1>');
Writeln(fi,ws[igrpws[htmlGroup].ia+28],'<UL>');
Case c Of
  'y':Writeln(fi,'<LI><A HREF="years.html">',ws[igrpws[htmlGroup].ia+32],'</A>,</LI>');
  'm':Writeln(fi,'<LI><A HREF="monthes.html">',ws[igrpws[htmlGroup].ia+33],'</A>,</LI>');
  'w':Writeln(fi,'<LI><A HREF="weeks.html">',ws[igrpws[htmlGroup].ia+34],'</A>.</LI>');
  End;
Writeln(fi,'</UL>');
Write(fi,'<TABLE BORDER><TR><TH>&nbsp;',ws[igrpws[htmlGroup].ia+37],'&nbsp;</TH><TH>&nbsp;');
If c<>'y' Then
  Begin
  If c='m' Then Write(fi,ws[igrpws[htmlGroup].ia+35]) Else
    Write(fi,ws[igrpws[htmlGroup].ia+36]);
  Write(fi,'&nbsp;</TH><TH>&nbsp;');
  End;
Writeln(fi,ws[igrpws[htmlGroup].ia+45],'&nbsp;</TH></TR>');
l:=ListGetList(ListDetail).ItemCount;
ka:=0;
Repeat
  Inc(ka);
  ListGetElement(ListDetail,ka);
  Until (x.s[5]=c) Or (ka>=l);
ke:=ka;
Repeat
  Inc(ke);
  If ke<=l Then ListGetElement(ListDetail,ke);
  Until (ke>l) Or (x.s[5]<>c);
Dec(ke);
If c='y' Then
  Begin
  la:=ka;
  Repeat
    le:=la;
    ListGetElement(ListDetail,la);
    sy:=Copy(x.s,1,4);
    Repeat
      Inc(le);
      If le<=ke Then ListGetElement(ListDetail,le);
      Until (le>ke) Or (sy<>Copy(x.s,1,4));
    Dec(le);
    Writeln(fi,'<TR><TD ROWSPAN=',le-la+1,' VALIGN=TOP>',sy,'</TD>');
    For l:=la To le Do If ListGetElement(ListDetail,l) Then
      Begin
      n1:=Pos(x.s[6],sAbbrev);
      n2:=Pos(x.s[7],sSortAbbrev);
      If l<>la Then Write(fi,'<TR>');
      If (n1>0) And (n2>0) Then
        Write(fi,'<TD><A HREF="',x.s,'">',aTitle[n1],
          ws[igrpws[htmlGroup].ia+13],sSortOpt[n2-1],'</A>') Else
        Write(fi,'<TD>',ws[igrpws[htmlGroup].ia+46],x.s,
          ws[igrpws[htmlGroup].ia+43],n1,ws[igrpws[htmlGroup].ia+48],
          n2);
      Writeln(fi,'</TD></TR>');
      End;
    la:=le+1;
    Until la>ke;
  End Else
  Begin
  la:=ka;
  Repeat
    le:=la;
    ListGetElement(ListDetail,la);
    sy:=Copy(x.s,1,4);
    Repeat
      Inc(le);
      If le<=ke Then ListGetElement(ListDetail,le);
      Until (le>ke) Or (sy<>Copy(x.s,1,4));
    Dec(le);
    { Von hier separat }
    Writeln(fi,'<TR><TD ROWSPAN=',le-la+1,' VALIGN=TOP>',sy,'</TD>');
    ma:=la;
    Repeat
      me:=ma;
      ListGetElement(ListDetail,ma);
      smw:=Copy(x.s,6,2);
      Repeat
        Inc(me);
        If me<=le Then ListGetElement(ListDetail,me);
        Until (me>le) Or (smw<>Copy(x.s,6,2));
      Dec(me);
      If ma<>ka Then Write(fi,'<TR>');
      Writeln(fi,'<TD ROWSPAN=',me-ma+1,' VALIGN=TOP>',smw,'</TD>');
      For m:=ma To me Do If ListGetElement(ListDetail,m) Then
        Begin
        If m<>ma Then Write(fi,'<TR>');
        n1:=Pos(x.s[8],sAbbrev);
        n2:=Pos(x.s[9],sSortAbbrev);
        If (n1>0) And (n2>0) Then
          Write(fi,'<TD><A HREF="',x.s,'">',aTitle[n1],
            ws[igrpws[htmlGroup].ia+13],sSortOpt[n2-1],'</A>') Else
          Write(fi,'<TD>',ws[igrpws[htmlGroup].ia+46],x.s,
            ws[igrpws[htmlGroup].ia+43],n1,ws[igrpws[htmlGroup].ia+48],
            n2);
        Writeln(fi,'</TD></TR>');
        End;
      ma:=me+1;
      Until ma>le;
    { Bis hier separat }
    la:=le+1;
    Until la>ke;
  End;
Writeln(fi,'</TABLE>');
Writeln(fi,'<A HREF="#ptop">',ws[igrpws[htmlGroup].ia+24],'</A><BR><BR>');
For k:=1 To nHtmlToe Do Writeln(fi,HtmlToe(k));
Close(fi);
{Writeln('detail close.');}
End;

Procedure WebDetail;
Var sr:Dos.SearchRec;
Begin
If OutputFlags.html_out And OutputFlags.html_index Then
  Begin
  x.nv:=0;
  Dos.FindFirst(sHtmlDir+'/2*.html',Dos.AnyFile,sr);
  While Doserror=0 Do
    Begin
    x.s:=sr.Name;
    x.n:=1;
    x.nb:=sr.Size;
    ListAddNew(ListDetail);
    Dos.FindNext(sr);
    End;
  Dos.FindClose(sr);
  ListSort(ListDetail,SortByStringDw);
  Writeln(ListGetList(ListDetail).ItemCount,ws[igrpws[htmlGroup].ia+49]);
  Detail('y',ws[igrpws[htmlGroup].ia+32]);
  Detail('m',ws[igrpws[htmlGroup].ia+33]);
  Detail('w',ws[igrpws[htmlGroup].ia+34]);
  Writeln(ws[igrpws[htmlGroup].ia+50],d2s(ListGetList(ListDetail).nks));
  End;
End;

Procedure WebOutClose(nBytes:LongInt);
Var k:Byte;
Begin
If OutputFlags.text_out Then
  Begin
  Writeln(ft);
  Writeln(ft,tform(ws[igrpws[htmlGroup].ia+25],nbytes),' kB');
  Close(ft);
{  Writeln('Closing text target.');}
  End;
If OutputFlags.html_out Then
  Begin
  For k:=1 To nHtmlToe Do Writeln(fhtml,HtmlToe(k));
  Close(fhtml);
{  Writeln('Closing Html-Target.');}
  End;
End;

Begin
With OutputFlags Do
  Begin
  text_out:=True;
  html_out:=True;
  html_week:=True;
  html_month:=True;
  html_year:=True;
  html_index:= True;
  End;
sTargetDir:='.';
sHtmlDir:='.';
sHtmlRobots:='noindex';
cdecsep:='.';
cksep:=',';
With sHtml Do
  Begin
  bgcolor:='#F0FFF0';
  iTables:=25;
  copyright:='<BR>&copy;2001 by <A HREF="mailto:gerd@dg4fac.de?subject=Weblox '+
    WebloxVersion+'">gerd@dg4fac.de</A>';
    End;
sHtmlVers:='<BR><FONT SIZE="1"><I>Created with Weblox, version '+WebLoxVersion+
  ', freeware by <a href="mailto:gerd@dg4fac.de?subject=Weblox '+WebLoxVersion+
  '">the author dg4fac</A>, see <a href="http://www.dg4fac.de">http://www.dg4fac.de</A></I></FONT>';
End.

